constant sTIMEFORMAT "0h:mm:ss"

function IO(string sInputfilename)

  //Variables declaration
  string sOutputfilename;   
  integer iErrorno;
  string sLogfile;
  string sLine;
  string sDay
  time tSubTotal;
  time tTotal;

  //Object declaration
  LogHandler log_handler;
  fsfileinputstream inputfile;
  fsfileoutputstream outputfile;

  //Variable initalisation
  sOutputfilename = "AdvancedIOOutput.txt"
  sLogfile = "AdvancedIO.log";
  iErrorno = -1
  sDay = ""
  tSubTotal =@ time.new()
  tTotal =@ time.new()
  tSubTotal.set(0,0,0,0,0);
  tTotal.set(0,0,0,0,0);

  //Object initialisation
  log_handler =@ LogHandler.new(sLogfile);
  inputfile =@ fsfileinputstream.new(sInputfilename,iErrorno);
  outputfile =@ fsfileoutputstream.new(sOutputfilename,iErrorno);

  if inputfile =@= .nul
    log_handler.error_message("No valid input file");
  else

  while inputfile.endofdata != .true
    sLine = inputfile.getstring(5000,1,terminator="{d}{a}");
    
    //Monday
    if .instr(sLine,"Mon") != 0 or (sDay == "Mon" and .lstr(sLine,1) !="W")
      if sDay != "Mon"
        if sDay != ""
          outputfile.putstring(sDay + " subtotal: " + .tostr(tSubTotal.hours(),10) + ":" + .tostr(tSubTotal.minutes(),10) + ":" + .tostr(tSubTotal.seconds(),10)+ "{d}{a}",1);
        end if 
        tTotal = tTotal + tSubTotal 
        sDay = "Mon"
        tSubTotal.set(0,0,0,0,0)
      end if
      tSubTotal = getTime(sLine,tSubTotal)

    //Tuesday
    else if .instr(sLine,"Tue") != 0 or (sDay == "Tue" and .lstr(sLine,1) !="W")
      if sDay != "Tue"
        if sDay != ""
          outputfile.putstring(sDay + " subtotal: " + .tostr(tSubTotal.hours(),10) + ":" + .tostr(tSubTotal.minutes(),10) + ":" + .tostr(tSubTotal.seconds(),10)+ "{d}{a}",1);
        end if 
        tTotal = tTotal + tSubTotal 
        sDay = "Tue"
        tSubTotal.set(0,0,0,0,0)
      end if
      tSubTotal = getTime(sLine,tSubTotal)

    //Wednesday
    else if .instr(sLine,"Wed") != 0 or (sDay == "Wed" and .lstr(sLine,1) !="W")
      if sDay != "Wed"
        if sDay != ""
          outputfile.putstring(sDay + " subtotal: " + .tostr(tSubTotal.hours(),10) + ":" + .tostr(tSubTotal.minutes(),10) + ":" + .tostr(tSubTotal.seconds(),10)+ "{d}{a}",1);
        end if 
        tTotal = tTotal + tSubTotal 
        sDay = "Wed"
        tSubTotal.set(0,0,0,0,0)
      end if
      tSubTotal = getTime(sLine,tSubTotal)

    //Thursday
    else if .instr(sLine,"Thu") != 0 or (sDay == "Thu" and .lstr(sLine,1) !="W")
      if sDay != "Thu"
        if sDay != ""
          outputfile.putstring(sDay + " subtotal: " + .tostr(tSubTotal.hours(),10) + ":" + .tostr(tSubTotal.minutes(),10) + ":" + .tostr(tSubTotal.seconds(),10)+ "{d}{a}",1);
        end if 
        tTotal = tTotal + tSubTotal 
        sDay = "Thu"
        tSubTotal.set(0,0,0,0,0)
      end if
      tSubTotal = getTime(sLine,tSubTotal)

    //Friday
    else if .instr(sLine,"Fri") != 0 or (sDay == "Fri" and .lstr(sLine,1) !="W")
      if sDay != "Fri"
        if sDay != ""
          outputfile.putstring(sDay + " subtotal: " + .tostr(tSubTotal.hours(),10) + ":" + .tostr(tSubTotal.minutes(),10) + ":" + .tostr(tSubTotal.seconds(),10)+ "{d}{a}",1);
        end if 
        tTotal = tTotal + tSubTotal 
        sDay = "Fri"
        tSubTotal.set(0,0,0,0,0)
      end if
      tSubTotal = getTime(sLine,tSubTotal)

    //Saturday
    else if .instr(sLine,"Sat") != 0 or (sDay == "Sat" and .lstr(sLine,1) !="W")
      if sDay != "Sat"
        if sDay != ""
          outputfile.putstring(sDay + " subtotal: " + .tostr(tSubTotal.hours(),10) + ":" + .tostr(tSubTotal.minutes(),10) + ":" + .tostr(tSubTotal.seconds(),10)+ "{d}{a}",1);
        end if 
        tTotal = tTotal + tSubTotal 
        sDay = "Sat"
        tSubTotal.set(0,0,0,0,0)
      end if
      tSubTotal = getTime(sLine,tSubTotal)

    //Sunday
    else if .instr(sLine,"Sun") != 0 or (sDay == "Sun" and .lstr(sLine,1) !="W")
      if sDay != "Sun"
        if sDay != ""
          outputfile.putstring(sDay + " subtotal: " + .tostr(tSubTotal.hours(),10) + ":" + .tostr(tSubTotal.minutes(),10) + ":" + .tostr(tSubTotal.seconds(),10)+ "{d}{a}",1);
        end if 
        tTotal = tTotal + tSubTotal 
        sDay = "Sun"
        tSubTotal.set(0,0,0,0,0)
      end if
      tSubTotal = getTime(sLine,tSubTotal)
    end if
  end while
  end if
outputfile.putstring("Total: " + .tostr(tTotal.hours(.true),10) + ":" + .tostr(tTotal.minutes(),10) +  ":" + .tostr(tTotal.seconds(),10) + "{d}{a}",1)    ;
end function "" 

function getTime(string sLine,time tTotal)
     if .instr(sLine, "SIMPOL:") != 0 and sLine != .nul;
         //Declaration of variables
         string temp;
         string sStartTime;
         string sEndTime;
         time tStartTime;
         time tEndTime;

         //Convert time strings to time objects (Need to initalise before can be used properly) (also set, if not being set elsewhere)
         tEndTime = time.new();
         tStartTime = time.new();

         //Get all times
         sLine = .rstr(sLine, 35)
         sLine = rtrim(sLine)
         sLine = ltrim(sLine)

         //Get just start and end time
         temp = .lstr(sLine, 17)
         temp = rtrim(temp)

         //Get Start time
         sStartTime = .lstr(temp,8)
         sStartTime = rtrim(sStartTime)

         //Get End time
         sEndTime = .rstr(temp,8)
         sEndTime = ltrim(sEndTime)

         tStartTime = string2time(sStartTime,sTIMEFORMAT);
         tEndTime = string2time(sEndTime,sTIMEFORMAT);
         tTotal = tTotal + (tEndTime - tStartTime);
    end if
end function tTotal         